# Lesson 2: Control flow

![the dude](/the-dude-meme.jpg)

## Key Concept: Conditions

The key concept of this lesson is the idea of **conditions**: "If this happens, do this...". Plain simple as set conditions to the inputs or parameters that you program takes. We will iterate a lot around this idea in the following. 

## If-else expressions

Here, the conditions are established based on specific truth values that we specify. In this case, these conditions are formulated in expressions that results in Boolean types. 

```rust
1 == 1 		// True
1 == 2 		// False
1 < 2 		// False
```

So after the `if` keyword you set the truth value that you want to set as condition.

```bash
if x > 10 {
	"It's greater than 10."
} else {
	"It's lesser than 10."
}
```

We can add more conditions with the `else if`expression:

```bash
if x > 10 {
	"It's greater than 10."
} else if x > 5 {
	"It's between from 5 to 10"
} else {
    "It's lesser than 5."
}
```

## When-is expression

Here unlike the if-else statements, in a `when is`expression you set as condition a type pattern that you want to match. 

```rust
when some_number is {
  0 -> "Zero"
  1 -> "One"
  2 -> "Two"
  n -> "Some other number" // This matches anything
}
```

Or see this another example: 

```rust
when my_list is {
  [] -> "This list is empty"
  [a] -> "This list has 1 element"
  [a, b] -> "This list has 2 elements"
  _other -> "This list has more than 2 elements"
}
```

So you don't expect a condition a True or False value, just a shape that you expect from a value. It's equivalent to `case` expressions or pattern matching in Haskell. 

## Expect 

A frequently encountered expression that often piques initial curiosity is the `expect` keyword.

```rust
expect [a] = some_list
```

However, it's important to note that this is essentially syntactic sugar of a trivial pattern match: "Expect this value shape, otherwise raise an error." In functional programming, it's a common practice to anticipate a single value match while discarding any other possibilities. 

Also, then you can use that a value in your program: 

```rust
expect [a] = some_list 

if a > 10 {
    "It's greater than 10."
} else {
	"It's lesser than 10."
}
```

## Pipe operator

In functional programming we call **function composition** when you apply a function to the return of another.

```rust
fn double (n: Int) -> Int {
    n * 2
}

fn increment (n: Int) -> Int {
    n + 1
}

// function composition
let result = increment(double(2)) // result == (n * 2) + 1 == 5
```

Here we see another syntactic sugar for this and its the pipe operator, which is equivalent to the previous function composition. 

```rust
let result = double(2) |> increment()
```

Which seems great to avoid some verbose function composition. When you have functions with multi parameters by default the pipe operator assign the result to the first argument, but you can specify the result in different argument order. 

```rust
fn subtraction (x: Int, y: Int) -> Int {
    x - y 
}

let subtraction_1 = 4 |> substraction(2) // subtraction(4,2) = 4 - 2 = 2
let substraction_2 = 4 |> substraction(2,_) // substraction(2,4) = 2 - 4 = -2
```



## The challenge: Exercises

Now, there are exercises for you to practice and achieve a good flow.

Go to the git lab repository and clone the main branch of the [ppbl-aiken-starter](https://gitlab.com/gimbalabs/ppbl-2023/ppbl-aiken-starter), in the validators folder there is an `exercises.ak`file with some problems and tests. 

Run the `aiken check`command inside the project, you will see at the top of the compiler message some test errors. **Your goal is to make these tests pass.** 

With this lesson you should be fine but also you will need to investigate the standard library API documentation. There you will find a lot of functions that will help you, specially those from the list module. Also at the end of the file you will find two exercises that need recursion to be solved. It is up to you to understand this very important concept of functional programming, you will find a lot info in the Internet that will help you. Please, any question don't doubt to bring it to the gimbalabs discord server. 

Lastly, if you need, you can refer to the `solved-exercises` branch. However, I strongly recommend doing so after giving your best effort to solve the exercises independently first (c'mon you've got this!). Then, after you've completed all the exercises on your own, you can explore the solutions provided by the course instructors to compare and contrast your approach for a deeper learning experience.




import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
